<?php

namespace AppBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use League\OAuth2\Client\Provider\GenericProvider;
use GuzzleHttp\Client as HttpClient;
use Firebase\JWT\JWT;
use Symfony\Component\HttpFoundation\JsonResponse;
use CCC\Request\V20170705\CheckNumberAvaliableRequest;
use CCC\Request\V20170705\AddAgentDeviceRequest;
use CCC\Request\V20170705\GetTURNCredentialsRequest;
use CCC\Request\V20170705\GetSmsConfigRequest;
use CCC\Request\V20170705\ListOutboundPhoneNumberOfUserRequest;
use CCC\Request\V20170705\GetTURNServerListRequest;
use CCC\Request\V20170705\GetConfigRequest;
use CCC\Request\V20170705\ListSkillGroupsOfUserRequest;
use CCC\Request\V20170705\RequestLoginInfoRequest;
use CCC\Request\V20170705\RefreshTokenRequest;
use CCC\Request\V20170705\ListConfigRequest;
use CCC\Request\V20170705\ListCallDetailRecordsRequest;
use CCC\Request\V20170705\DownloadRecordingRequest;
use CCC\Request\V20170705\ListRecordingsByContactIdRequest;
use CCC\Request\V20170705\GenerateAgentStatisticReportRequest;
use CCC\Request\V20170705\LaunchAppraiseRequest;
use CCC\Request\V20170705\PickLocalNumberRequest;
use CCC\Request\V20170705\GetServiceExtensionsRequest;
use CCC\Request\V20170705\GetNumberRegionInfoRequest;
use CCC\Request\V20170705\ListRealTimeAgentRequest;
use CCC\Request\V20170705\ListRecentCallRecordsRequest;


class HomeController extends Controller
{
    private $clientId = "";
    private $clientSecret = "";

    /**
     * @Route("/", name="homepage")
     */
    public function indexAction()
    {
        return $this->render('login.html.twig', array('message' => 'Please enter username and password hello.'));
        //return $this->render('home.html.twig', array('message'=>'Please enter username and password.'));
    }

    /**
     * @Route("/skip", name="homeskip")
     */
    public function skipAction(Request $request)
    {
        $users = array(array('username' => '张三', 'password' => '1234'), array('username' => '李四', 'password' => '5678'));
        $username = $request->request->get('username');
        $password = $request->request->get('password');
        // var_dump($username.','.$password);
        // die;
        foreach ($users as $user) {
            if ($user['username'] . ":" . $user['password'] === $username . ":" . $password) {
                return $this->redirect('/homepage');
            }
        }
        return $this->render('login.html.twig', array('message' => 'Invalid username and password.'));
    }

    public function homepageAction()
    {
        return $this->render('home.html.twig', array(
            'userName' => 'Jackson',
            'isAliyunBound' => false,
        ));
    }

    public function loginAction()
    {

        $provider = new GenericProvider([
            'clientId' => $this->clientId,    // The client ID assigned to you by the provider
            'clientSecret' => $this->clientSecret,   // The client password assigned to you by the provider
            'redirectUri' => 'https://127.0.0.1:8443/aliyun/auth/callback',
            'urlAuthorize' => 'https://signin.aliyun.com/oauth2/v1/auth',
            'urlAccessToken' => 'https://oauth.aliyun.com/v1/token',
            'urlResourceOwnerDetails' => 'any things',
            'accessType' => 'offline'
        ]);

        /* 'redirectUri'             => 'https://127.0.0.1:8443/aliyun/auth/callback',
          'urlAuthorize'            => 'https://signin.aliyun.com/oauth2/v1/auth',
          'urlAccessToken'          => 'https://oauth.aliyun.com/v1/token',*/

        $authorizationUrl = $provider->getAuthorizationUrl();
        return $this->redirect($authorizationUrl);
    }

    public function callbackAction(Request $request)
    {
        $code = $request->query->get('code');
        $state = $request->query->get('state');
        // code=ABAFDGDFXYZW888&state=1234567890
        $provider = new GenericProvider([
            'clientId' => $this->clientId,    // The client ID assigned to you by the provider
            'clientSecret' => $this->clientSecret,   // The client password assigned to you by the provider
            'redirectUri' => 'https://127.0.0.1:8443/aliyun/auth/callback',
            'urlAuthorize' => 'https://signin.aliyun.com/oauth2/v1/auth',
            'urlAccessToken' => 'http://oauth.aliyun.com/v1/token',
            'urlResourceOwnerDetails' => 'any things'
        ]);

        $token = $provider->getAccessToken('authorization_code', [
            'code' => $code,
            'grant_type' => 'authorization_code'
        ]);
        //var_dump($token); die;
        $accessToken = $token->getToken();
        $refreshToken = $token->getRefreshToken();

        $sess = $request->getSession();
        $sess->set('accessToken', $accessToken);
        $sess->set('refreshToken', $refreshToken);

        //var_dump($sess->get('c4c76b8a-b022-45ee-b032-518e55dda056'));
        // {
        //   "access_token": {
        //     "AccessKeySecret": "FwAz8uoYzAW6k911HMfdsd8VNU9H1jztAKBQP21yAqfL8U1G",
        //     "AccessKeyId": "STS.GmZK152nfdsdmvJhaaUfeGQ9K4WeC",
        //     "SecurityToken": "CAIS8gF1q6Ft5sf..."
        //   },
        //   "token_type": "AliyunSTS",
        //   "expires_in": 3600,
        //   "refresh_token": "Ccx63VVeTn2dxV7ovXXfLtAqLLERAH1Bc",
        //   "id_token": "eyJhbGciOiJIUzI1N..."
        // }

        return $this->redirect('/home');
        // call OPENAPI with sts access token
    }

    public function homeAction()
    {
        return $this->render('home.html.twig', array(
            'userName' => 'Jackson',
            'isAliyunBound' => true,
        ));
    }

    public function refreshAction(Request $request)
    {
        $refreshToken = $request->getSession()->get('refreshToken');
        /* var_dump($session);
        echo "<hr/>";
        var_dump($request);
        echo "<hr/>";
        var_dump($accessToken); */
        //var_dump($accessToken);
        //die;
        $provider = new GenericProvider([
            'clientId' => $this->clientId,    // The client ID assigned to you by the provider
            'clientSecret' => $this->clientSecret,   // The client password assigned to you by the provider
            'urlAuthorize' => 'https://signin.aliyun.com/oauth2/v1/auth',
            'urlAccessToken' => 'http://oauth.aliyun.com/v1/token',
            'urlResourceOwnerDetails' => 'any things'
        ]);
        $token = $provider->getAccessToken('refresh_token', [
            'refresh_token' => $refreshToken,
            'grant_type' => 'refresh_token'
        ]);
        //var_dump($token); die;
        $sess = $request->getSession();
        $sess->set('accessToken', $token->getToken());
        return $this->redirect('/home');
    }

    /**
     * @Route("/revoke", name="homeskip")
     */
    public function revokeAction(Request $request)
    {
        $refreshToken = $request->getSession()->get('refreshToken');

        $client = new HttpClient();
        $response = $client->request('GET', 'https://oauth.aliyun.com/v1/revoke', [
            'query' => ['client_id' => $this->clientId,
                'client_secret' => $this->clientSecret,
                'token' => $refreshToken]
        ]);
        //var_dump($response); die;
        $request->getSession()->clear();
        return $this->redirect('/homepage');
    }

    public function ajaxapiAction(Request $request)
    {

        $action = $request->query->get('action');
        switch ($action) {
            case "CheckNumberAvaliable":
                $response = $this->CheckNumberAvaliable($request);
                break;
            case "AddAgentDevice":
                $response = $this->AddAgentDevice($request);
                break;
            case "GetTurnCredentials":
                $response = $this->GetTurnCredentials($request);
                break;
            case "GetSmsConfig":
                $response = $this->GetSmsConfig($request);
                break;
            case "ListOutboundPhoneNumberOfUser":
                $response = $this->ListOutboundPhoneNumberOfUser($request);
                break;
            case "GetTurnServerList":
                $response = $this->GetTurnServerList($request);
                break;
            case "GetConfig":
                $response = $this->GetConfig($request);
                break;
            case "RequestLoginInfo":
                $response = $this->RequestLoginInfo($request);
                break;
            case "ListSkillGroupsOfUser":
                $response = $this->ListSkillGroupsOfUser($request);
                break;
            case "GetNumberRegionInfo":
                $response = $this->GetNumberRegionInfo($request);
                break;
            case "GetServiceExtensions":
                $response = $this->GetServiceExtensions($request);
                break;
            case "PickLocalNumber":
                $response = $this->PickLocalNumber($request);
                break;
            case "ListConfig":
                $response = $this->ListConfig($request);
                break;
            case "LaunchAppraise":
                $response = $this->LaunchAppraise($request);
                break;
            case "GenerateAgentStatisticReport":
                $response = $this->GenerateAgentStatisticReport($request);
                break;
            case "ListRecordingsByContactId":
                $response = $this->listRecordingsByContactId($request);
                break;
            case "DownloadRecording":
                $response = $this->DownloadRecording($request);
                break;
            case "ListCallDetailRecords":
                $response = $this->ListCallDetailRecords($request);
                break;
            case "ListRealTimeAgent":
                $response = $this->ListRealTimeAgent($request);
                break;
            case "ListRecentCallRecords":
                $response = $this->ListRecentCallRecords($request);
                break;
        }

        return $response;
    }

    public function CheckNumberAvaliable(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];
        $callee = $json['callee'];
        $caller = array_key_exists("caller", $json) ? $json['caller'] : null;

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/CheckNumberAvaliableRequest.php");


        $request = new CheckNumberAvaliableRequest();
        $request->setInstanceId($instanceId);
        $request->setCaller($caller);
        $request->setCallee($callee);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }

    public function AddAgentDevice(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];
        $browserVersion = $json['browserVersion'];
        $clientIp = $json['clientIp'];
        $clientPort = array_key_exists("clientPort", $json) ? $json['clientPort'] : null;
        $remark = array_key_exists("remark", $json) ? $json['remark'] : null;

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/AddAgentDeviceRequest.php");


        $request = new AddAgentDeviceRequest();
        $request->setInstanceId($instanceId);
        $request->setRemark($remark);
        $request->setClientPort($clientPort);
        $request->setClientIp($clientIp);
        $request->setBrowserVersion($browserVersion);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }

    public function GetTurnCredentials(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];
        $userName = $json['UserName'];

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        // var_dump(dirname(__FILE__)."/../../../plugin/aliyun-php-sdk-core/Config.php");
        // die;
        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");

        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");

        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/GetTURNCredentialsRequest.php");

        $request = new GetTURNCredentialsRequest();
        $request->setInstanceId($instanceId);
        $request->setUserName($userName);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);

    }

    public function GetSmsConfig(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];
        $scenarios = $json['scenarios'];

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        // var_dump(dirname(__FILE__)."/../../../plugin/aliyun-php-sdk-core/Config.php");
        // die;
        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");

        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");

        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/GetSmsConfigRequest.php");

        $request = new GetSmsConfigRequest();
        $request->setInstanceId($instanceId);
        $request->setScenarios($scenarios);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);

    }

    public function ListOutboundPhoneNumberOfUser(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];
        $userId = $json['userId'];
        $pageSize = array_key_exists("PageSize", $json) ? $json['PageSize'] : null;
        $pageNumber = array_key_exists("PageNumber", $json) ? $json['PageNumber'] : null;

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/ListOutboundPhoneNumberOfUserRequest.php");


        $request = new ListOutboundPhoneNumberOfUserRequest();
        $request->setInstanceId($instanceId);
        $request->setUserId($userId);
        $request->setPageSize($pageSize);
        $request->setPageNumber($pageNumber);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }

    public function GetTurnServerList(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        // var_dump(dirname(__FILE__)."/../../../plugin/aliyun-php-sdk-core/Config.php");
        // die;
        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");

        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");

        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/GetTURNServerListRequest.php");

        $request = new GetTURNServerListRequest();
        $request->setInstanceId($instanceId);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);

    }

    public function GetConfig(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $name = $json['name'];
        $instanceId = $json['instanceId'];
        $objectType = $json['objectType'];
        $objectId = $json['objectId'];

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        // var_dump(dirname(__FILE__)."/../../../plugin/aliyun-php-sdk-core/Config.php");
        // die;
        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");

        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");

        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/GetConfigRequest.php");

        $request = new GetConfigRequest();
        $request->setInstanceId($instanceId);
        $request->setName($name);
        $request->setObjectType($objectType);
        $request->setObjectId($objectId);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);

    }

    public function RequestLoginInfo(Request $request)
    {


        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $userId = $json['userId'];
        $instanceId = $json['instanceId'];

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');

        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");

        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");

        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/RequestLoginInfoRequest.php");

        $request = new RequestLoginInfoRequest();
        $request->setInstanceId($instanceId);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);

    }

    public function ListSkillGroupsOfUser(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $userId = $json['userId'];
        $instanceId = $json['instanceId'];


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/ListSkillGroupsOfUserRequest.php");


        $request = new ListSkillGroupsOfUserRequest();
        $request->setInstanceId($instanceId);
        $request->setUserId($userId);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function GetNumberRegionInfo(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $number = array_key_exists("number", $json) ? $json['number'] : null;
        $instanceId = array_key_exists("instanceId", $json) ? $json['instanceId'] : null;


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/GetNumberRegionInfoRequest.php");


        $request = new GetNumberRegionInfoRequest();
        $request->setInstanceId($instanceId);
        $request->setNumber($number);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function GetServiceExtensions(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $serviceType = $json['serviceType'];
        $instanceId = $json['instanceId'];


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/GetServiceExtensionsRequest.php");


        $request = new GetServiceExtensionsRequest();
        $request->setInstanceId($instanceId);
        $request->setServiceType($serviceType);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function PickLocalNumber(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $candidateNumbers = array_key_exists("candidateNumbers", $json) ? $json['candidateNumbers'] : null;
        $calleeNumber = array_key_exists("calleeNumber", $json) ? $json['calleeNumber'] : null;
        $instanceId = array_key_exists("instanceId", $json) ? $json['instanceId'] : null;


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/PickLocalNumberRequest.php");


        $request = new PickLocalNumberRequest();
        $request->setInstanceId($instanceId);
        $request->setCandidateNumbers($candidateNumbers);
        $request->setCalleeNumber($calleeNumber);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function ListConfig(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $configItems = $json['configItems'];
        $instanceId = $json['instanceId'];


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/ListConfigRequest.php");


        $request = new ListConfigRequest();
        $request->setInstanceId($instanceId);
        $request->setConfigItems($configItems);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function LaunchAppraise(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $acid = array_key_exists("acid", $json) ? $json['acid'] : null;
        $instanceId = array_key_exists("instanceId", $json) ? $json['instanceId'] : null;


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/LaunchAppraiseRequest.php");


        $request = new LaunchAppraiseRequest();
        $request->setInstanceId($instanceId);
        $request->setAcid($acid);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function GenerateAgentStatisticReport(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $agentId = array_key_exists("AgentId", $json) ? $json['AgentId'] : null;
        $StartDay = array_key_exists("StartDay", $json) ? $json['StartDay'] : null;
        $endDate = array_key_exists("EndDate", $json) ? $json['EndDate'] : null;
        $pageSize = array_key_exists("PageSize", $json) ? $json['PageSize'] : null;
        $startDate = array_key_exists("StartDate", $json) ? $json['StartDate'] : null;
        $pageNumber = array_key_exists("PageNumber", $json) ? $json['PageNumber'] : null;
        $instanceId = array_key_exists("instanceId", $json) ? $json['instanceId'] : null;

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/GenerateAgentStatisticReportRequest.php");


        $request = new GenerateAgentStatisticReportRequest();
        $request->setInstanceId($instanceId);
        $request->setAgentId($agentId);
        $request->setEndDate($endDate);
        $request->setPageSize($pageSize);
        $request->setStartDate($startDate);
        $request->setPageNumber($pageNumber);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function ListRecordingsByContactId(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $contactId = $json['contactId'];
        $instanceId = $json['instanceId'];


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/ListRecordingsByContactIdRequest.php");


        $request = new ListRecordingsByContactIdRequest();
        $request->setInstanceId($instanceId);
        $request->setContactId($contactId);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function DownloadRecording(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $fileName = array_key_exists("fileName", $json) ? $json['fileName'] : null;
        $channel = array_key_exists("channel", $json) ? $json['channel'] : null;
        $instanceId = array_key_exists("instanceId", $json) ? $json['instanceId'] : null;


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/DownloadRecordingRequest.php");


        $request = new DownloadRecordingRequest();
        $request->setInstanceId($instanceId);
        $request->setFileName($fileName);
        $request->setChannel($channel);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function ListRealTimeAgent(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/ListRealTimeAgentRequest.php");


        $request = new ListRealTimeAgentRequest();
        $request->setInstanceId($instanceId);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function ListRecentCallRecords(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];
        $criteria = array_key_exists("criteria", $json) ? $json['criteria'] : null;
        $pageSize = array_key_exists("pageSize", $json) ? $json['pageSize'] : null;
        $orderBy = array_key_exists("orderBy", $json) ? $json['orderBy'] : null;
        $stopTime = array_key_exists("stopTime", $json) ? $json['stopTime'] : null;
        $startTime = array_key_exists("startTime", $json) ? $json['startTime'] : null;
        $pageNumber = array_key_exists("pageNumber", $json) ? $json['pageNumber'] : null;
        $withRecording = array_key_exists("withRecording", $json) ? $json['withRecording'] : null;

        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/ListRecentCallRecordsRequest.php");


        $request = new ListRecentCallRecordsRequest();
        $request->setInstanceId($instanceId);
        // $request->setCriteria($criteria);
        $request->setPageSize($pageSize);
        // $request->setOrderBy($orderBy);
        $request->setStopTime($stopTime);
        $request->setStartTime($startTime);
        $request->setPageNumber($pageNumber);
        // $request->setWithRecording($withRecording);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function ListCallDetailRecords(Request $request)
    {

        $param = $request->request->get('request');
        $json = json_decode($param, true);
        $instanceId = $json['instanceId'];
        $contactDisposition = array_key_exists("contactDisposition", $json) ? $json['contactDisposition'] : null;
        $contactType = array_key_exists("contactType", $json) ? $json['contactType'] : null;
        $criteria = array_key_exists("criteria", $json) ? $json['criteria'] : null;
        $phoneNumber = array_key_exists("phoneNumber", $json) ? $json['phoneNumber'] : null;
        $pageSize = array_key_exists("pageSize", $json) ? $json['pageSize'] : null;
        $orderBy = array_key_exists("orderBy", $json) ? $json['orderBy'] : null;
        $stopTime = array_key_exists("stopTime", $json) ? $json['stopTime'] : null;
        $startTime = array_key_exists("startTime", $json) ? $json['startTime'] : null;
        $pageNumber = array_key_exists("pageNumber", $json) ? $json['pageNumber'] : null;
        $withRecording = array_key_exists("withRecording", $json) ? $json['withRecording'] : null;


        $session = $request->getSession();
        $userInfo = $session->get($instanceId);
        $accessToken = $session->get('accessToken');


        //引入sdk,只做参考，按自己的项目配置来
        include_once(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-core/Config.php");


        //接口调用过程
        $clientProfile = \DefaultProfile::getBearerTokenProfile("cn-shanghai", $accessToken);

        \DefaultProfile::addEndpoint("CCC", "cn-shanghai", "CCC", "ccc.cn-shanghai.aliyuncs.com");


        //引入sdk,只做参考
        include(dirname(__FILE__) . "/../../../plugin/aliyun-php-sdk-ccc/CCC/Request/V20170705/ListCallDetailRecordsRequest.php");


        $request = new ListCallDetailRecordsRequest();
        $request->setInstanceId($instanceId);
        $request->setContactDisposition($contactDisposition);
        $request->setContactType($contactType);
        $request->setCriteria($criteria);
        $request->setPhoneNumber($phoneNumber);
        $request->setPageSize($pageSize);
        $request->setOrderBy($orderBy);
        $request->setStopTime($stopTime);
        $request->setStartTime($startTime);
        $request->setPageNumber($pageNumber);
        $request->setWithRecording($withRecording);

        $client = new \DefaultAcsClient($clientProfile);
        $response = $client->getAcsResponse($request);

        $destination = array();

        $this->copyObject($destination, $response);

        return new JsonResponse($destination);
    }


    public function copyObject(&$destination, $jsonObject)
    {

        foreach ($jsonObject as $key => $val) {
            $lower = strtolower(substr($key, 0, 1));
            $lowerLet = $lower . substr($key, 1);
            $destination[$lowerLet] = $val;

            if (is_object($val)) {
                if (count((array)$val) == 1) {
                    $theone = reset($val);
                    $newObject = array();
                    $this->copyArray($newObject, $theone);
                    $destination[$lowerLet] = $newObject;
                    continue;
                }

                $newObject = array();
                $this->copyObject($newObject, $val);
                $destination[$lowerLet] = $newObject;


            } else if (is_array($val)) {
                $newObject = array();
                $this->copyArray($newObject, $val);
                $destination[$lowerLet] = $newObject;
            }
        }
    }

    public function copyArray(&$destination, $jsonArray)
    {
        if (is_array($jsonArray)) {
            foreach ($jsonArray as $value) {
                if (is_object($value)) {
                    $newObject = array();
                    $this->copyObject($newObject, $value);
                    array_push($destination, $newObject);
                } else if (is_array($value)) {
                    $newArray = array();
                    $this->copyArray($newArray, $value);
                    array_push($destination, $newArray);
                } else {
                    array_push($destination, $value);
                }
            }
        }
    }

}